﻿// <copyright file="Program.cs" company="ANUJ Technologies Inc.">
// Copyright (c) 2013 All Rights Reserved. You may use this source code as long as the copyright header is kept intact.
// </copyright>
// <author>Anuj Varma</author>
// <blog>http://www.anujvarma.com/category/technology/</blog>
// <date>11/19/2013</date>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PublishSubscribeCSharp
{
    class Program
    {        
        static void Main(string[] args)
        {
            // Hooking up the publisher and subscriber(s) in the client code

            EmployerPublisher publisher = new EmployerPublisher();

            // Two different subscribers
            Employee employee1 = new Employee("Employee 1");
            Employee employee2 = new Employee("Employee 2");

            // Workaround to gothcha 2 (adding new subscriber while notification is in progress)
            // When we 'add' a new subscriber, it always goes to the top of the Linked List
            publisher.AddSubscriber(employee1);
            publisher.AddSubscriber(employee2); 

            // Now that the subscribers are hooked up, the event can be fired
            DateTime now = DateTime.Now;
            publisher.FireEvent(now.Date);

            // Remember to Unsubscribe (detach the subscriber from the event)
            publisher.RemoveSubscriber(employee1);
            publisher.RemoveSubscriber(employee2);
        }


    }
}